from ...services import project, printer
import json
import os
from terminal import confirm

def remove(task_name, yes=False):

    type = project.check_is_job_project()

    if type != 'python':
        raise Exception('Only support python type project currently')

    if not yes and yes != 'true':
        if not confirm('To remove task: %s, are you sure' % task_name):
            return 0

    with open('./job.json', 'r') as f:
        obj = json.loads(f.read())

    if not obj.get('TaskDag'):
        obj['TaskDag'] = {}
    if not obj['TaskDag'].get('TaskDescMap'):
        obj['TaskDag']['TaskDescMap'] = {}


    obj['TaskDag']['Dependencies'] = remove_dep(obj['TaskDag']['Dependencies'], task_name)

    if obj['TaskDag']['TaskDescMap'].get(task_name):
        obj['TaskDag']['TaskDescMap'].pop(task_name)

    with open('./job.json', 'w') as f:
        f.write(json.dumps(obj, indent=2))
    print('remove task %s from job.json' % task_name)

    remove_task_file(task_name)


    printer.done()

def remove_dep(deps, task_name):
    if deps.get(task_name) !=None:
        deps.pop(task_name)

    for k in deps:

        if task_name in deps[k]:
            vset = set(deps[k])
            vset = vset.remove(task_name)
            deps[k] = [i for i in vset]
    return deps

def remove_task_file(task_name):
    p = 'src/%s.py' % task_name
    if os.path.exists(p):
        os.remove(p)
        print('remove %s success' % p)

def getDefauleTaskDesc(task_name):
    return  {
        "ImageId": "",
        "InstanceCount": 3,
        "OssMappingLocale": "UTF-8",
        "OssMappingLock": True,
        "OssMapping": {},
        "PackageUri": "",
        "ProgramType": "python",
        "ProgramName": "%s.py" % task_name,
        "ProgramArguments": "",
        "ResourceDescription": {
            "Cpu": 800,
            "Memory": 2000
        },
        "StderrRedirectPath": "",
        "StdoutRedirectPath": "",
        "Timeout": 3000
    }